#version 460 core

layout (location = 0) in vec3 a_pos;
layout (location = 1) in vec3 a_normal;
layout (location = 2) in vec3 a_tangent;
layout (location = 3) in vec3 a_bitangent;
layout (location = 4) in vec2 a_uv;

out vec3 position;
out vec3 normal;
out vec3 tangent;
out vec3 bitangent;
out vec2 uv;

out mat3 tbn;

uniform mat4 vp;
uniform mat4 model;

// https://learnopengl.com/Advanced-Lighting/Normal-Mapping
mat3 calcTBN(mat4 model)
{
   vec3 T = normalize(vec3(model * vec4(a_tangent,   0.0)));
   vec3 B = normalize(vec3(model * vec4(a_bitangent, 0.0)));
   vec3 N = normalize(vec3(model * vec4(a_normal,    0.0)));
   mat3 TBN = mat3(T, B, N);
   return TBN;
}

void main() {
    vec4 position4 = vec4(a_pos, 1.0);
    gl_Position = vp * model * position4;
    position = vec3(model * position4);

    normal = a_normal;
    tangent = a_tangent;
    bitangent = a_bitangent;
    tbn = calcTBN(model);

    uv = a_uv;
}