#version 460 core

layout (location = 0) in vec3 a_pos;

out vec3 position;
out vec3 normal;
out vec4 clip_space;
out vec2 tex_coords;

uniform mat4 vp;
uniform mat4 model;
uniform float cloud_scale;

void main() {
    clip_space = vp * model * vec4(a_pos, 1.0);
    position = vec3(model * vec4(a_pos, 1.0));
    gl_Position = clip_space;
    tex_coords = cloud_scale * (vec2(a_pos.x, a_pos.z) * 0.5 + 0.5);
}