#version 460 core

in vec3 position;

out vec4 o_colour;

uniform vec3 obj_pos;
uniform vec3 colour;
uniform vec3 cam_pos;

struct Light {
    vec3 position;
    vec3 ambient;
    vec3 diffuse;
    vec3 specular;
};
uniform Light light;

float ray_sphere(vec3 o, vec3 d, vec3 p, float r) {
    vec3 off = o - p;
    float aa = dot(d, d);
    float bb = 2.0 * dot(off, d);
    float cc = dot(off, off) - r * r;
    float det = bb * bb - 4.0 * aa * cc;
    if (det > 0.0) {
        float rt = sqrt(det);
        return max(0.0, (-bb - rt) / (2.0 * aa));
    }
    return -1;

}

void main() {
    vec3 res_colour = colour;
    vec3 cam_dir = normalize(position - cam_pos);
    vec3 light_dir = normalize(light.position - position);
    float t = ray_sphere(cam_pos, cam_dir, obj_pos, 0.5);
    if (t >= 0.0) {
        vec3 intpt = cam_pos + t * cam_dir;
        vec3 normal = normalize(intpt - obj_pos);
        vec3 ambient = light.ambient;
        float diff = max(dot(light_dir, normal), 0.0);
        vec3 diffuse = light.diffuse * diff;

        res_colour = vec3(0, 1, 0) * (ambient + diffuse);
        o_colour = vec4(res_colour, 1.0);
    } else {
        discard;
    }
    //     o_colour = vec4(res_colour, 0.0);
    o_colour = vec4(res_colour, 1.0);
}