#version 460 core

in vec3 position;
flat in vec3 normal;
// flat in ivec4 bone_ids;
// in vec4 bone_weights;

out vec4 o_colour;

uniform vec3 colour;
uniform vec3 cam_pos;
uniform int display_bone_id;

struct Light {
    vec3 position;
    vec3 ambient;
    vec3 diffuse;
    vec3 specular;
};
uniform Light light;


void main() {
    vec3 ambient = light.ambient;

    vec3 light_dir = normalize(light.position - position);
    float diff = max(dot(light_dir, normal), 0.0);
    vec3 diffuse = light.diffuse * diff;

    vec3 view_dir = normalize(cam_pos - position);
    // blinn-phong specular calculation
    vec3 halfway_dir = normalize(light_dir + view_dir);
    // hard-code the specular values from the .mtl file
    float spec = pow(max(dot(normal, halfway_dir), 0.0), 96);
    vec3 specular = light.specular * spec * 0.5;

    vec3 res_colour = (ambient + diffuse + specular) * colour;

    o_colour = vec4(res_colour, 1.0);
    // o_colour = vec4(normal * 0.5 + 0.5, 1.0);
}