#version 460 core

layout (location = 0) in vec3 a_pos;
layout (location = 1) in vec3 a_normal;

out vec3 position;
flat out vec3 normal;
// flat out ivec4 bone_ids;
// out vec4 bone_weights;

uniform mat4 vp;
uniform mat4 model;
uniform mat3 tinv_model;
// frequency, speed, amplitude, offset
uniform vec4 wave_params;
uniform float ct;

void main() {
    vec3 p = a_pos;
    p.x += p.y * wave_params.z * sin(wave_params.x * (p.y - wave_params.y * ct) + wave_params.w);
    p.z -= p.y * wave_params.z * sin(wave_params.x * (p.y - wave_params.y * ct) + wave_params.w);
    position = vec3(model * vec4(p, 1.0));
    gl_Position = vp * vec4(position, 1.0);
    normal = normalize(tinv_model * a_normal);
}